/*
 * Copyright 2010-2014 Ning, Inc.
 * Copyright 2014-2020 Groupon, Inc
 * Copyright 2020-2021 Equinix, Inc
 * Copyright 2014-2021 The Billing Project, LLC
 *
 * The Billing Project licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */


package org.killbill.billing.client.model.gen;

import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;
import org.killbill.billing.client.model.gen.UnitUsageRecord;

/**
 *           DO NOT EDIT !!!
 *
 * This code has been generated by the Kill Bill swagger generator.
 *  @See https://github.com/killbill/killbill-swagger-coden
 */
import org.killbill.billing.client.model.KillBillObject;

public class SubscriptionUsageRecord {

    private UUID subscriptionId = null;

    private String trackingId = null;

    private List<UnitUsageRecord> unitUsageRecords = new ArrayList<UnitUsageRecord>();


    public SubscriptionUsageRecord() {
    }

    public SubscriptionUsageRecord(final UUID subscriptionId,
                     final String trackingId,
                     final List<UnitUsageRecord> unitUsageRecords) {
        this.subscriptionId = subscriptionId;
        this.trackingId = trackingId;
        this.unitUsageRecords = unitUsageRecords;

    }


    public SubscriptionUsageRecord setSubscriptionId(final UUID subscriptionId) {
        this.subscriptionId = subscriptionId;
        return this;
    }

    public UUID getSubscriptionId() {
        return subscriptionId;
    }

    public SubscriptionUsageRecord setTrackingId(final String trackingId) {
        this.trackingId = trackingId;
        return this;
    }

    public String getTrackingId() {
        return trackingId;
    }

    public SubscriptionUsageRecord setUnitUsageRecords(final List<UnitUsageRecord> unitUsageRecords) {
        this.unitUsageRecords = unitUsageRecords;
        return this;
    }

    public SubscriptionUsageRecord addUnitUsageRecordsItem(final UnitUsageRecord unitUsageRecordsItem) {
        this.unitUsageRecords.add(unitUsageRecordsItem);
        return this;
    }

    public List<UnitUsageRecord> getUnitUsageRecords() {
        return unitUsageRecords;
    }

    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        SubscriptionUsageRecord subscriptionUsageRecord = (SubscriptionUsageRecord) o;
        return Objects.equals(this.subscriptionId, subscriptionUsageRecord.subscriptionId) &&
            Objects.equals(this.trackingId, subscriptionUsageRecord.trackingId) &&
            Objects.equals(this.unitUsageRecords, subscriptionUsageRecord.unitUsageRecords);
    }

    @Override
    public int hashCode() {
        return Objects.hash(subscriptionId,
            trackingId,
            unitUsageRecords);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class SubscriptionUsageRecord {\n");
        
        sb.append("    subscriptionId: ").append(toIndentedString(subscriptionId)).append("\n");
        sb.append("    trackingId: ").append(toIndentedString(trackingId)).append("\n");
        sb.append("    unitUsageRecords: ").append(toIndentedString(unitUsageRecords)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

